package com.gx.obe.bpt.composite;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.Optional;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Widget;

import com.gx.obe.ColorConstants;
import com.gx.obe.bpt.entity.BidPriceTable;
import com.gx.obe.bpt.entity.BidPriceTableItem;
import com.gx.obe.bpt.entity.BidPriceTableItemCollect;
import com.gx.obe.bpt.entity.BidPriceTableTitle;
import com.gx.obe.bpt.enumeration.BidPriceTableType;
import com.gx.obe.bpt.enumeration.ContentAlignment;
import com.gx.obe.bpt.service.BidPriceTableService;
import com.gx.obe.components.core.Constants;
import com.gx.obe.util.utils.Keys;
import com.swtdesigner.SWTResourceManager;

import de.kupzog.ktable.KTable;
import de.kupzog.ktable.SWTX;
import de.kupzog.ktable.model.CommonKtableCModel;

/** 
 * @Description: 
 * @author chenxw 
 */
public class BidPriceTableInfoListComposite extends Composite {
	
	private final BidPriceTableService bidPriceTableService = new BidPriceTableService();
	
	private ScrolledComposite tableItemScrolled;
	private Composite tableItemComposite;
	
	private BidPriceTableItemButton curButton;
	private Label tableNameLabel;
	private Composite detailComposite;
	private Composite collectComposite;
	
	private String tenderId;
	private String supplierId;


	
	/** 
	 * @author chenxw
	 * @param parent
	 * @param style 
	 */
	public BidPriceTableInfoListComposite(Composite parent, int style) {
		super(parent, style);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		setBackgroundMode(SWT.INHERIT_FORCE);
		
		Composite composite = new Composite(this, SWT.NONE);
		GridLayout gl_composite = new GridLayout(3, false);
		gl_composite.horizontalSpacing = 0;
		gl_composite.marginHeight = 0;
		gl_composite.marginWidth = 0;
		composite.setLayout(gl_composite);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		Composite composite_1 = new Composite(composite, SWT.NONE);
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.marginHeight = 1;
		gl_composite_1.marginWidth = 0;
		composite_1.setLayout(gl_composite_1);
		GridData gd_composite_1 = new GridData(SWT.LEFT, SWT.FILL, false, true, 1, 1);
		gd_composite_1.widthHint = 170;
		composite_1.setLayoutData(gd_composite_1);
		
		tableItemScrolled = new ScrolledComposite(composite_1, SWT.V_SCROLL);
		tableItemScrolled.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		tableItemScrolled.setExpandHorizontal(true);
		tableItemScrolled.setExpandVertical(true);
		
		tableItemComposite = new Composite(tableItemScrolled, SWT.NONE);
		GridLayout gl_tableItemComposite = new GridLayout(1, false);
		gl_tableItemComposite.verticalSpacing = 0;
		gl_tableItemComposite.marginHeight = 0;
		gl_tableItemComposite.marginWidth = 0;
		tableItemComposite.setLayout(gl_tableItemComposite);
		
		tableItemScrolled.setContent(tableItemComposite);
		tableItemScrolled.setMinSize(tableItemComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		
		ESepator vertical_label = new ESepator(composite, SWT.SEPARATOR | SWT.VERTICAL);
		vertical_label.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false, true, 1, 1));
		vertical_label.setBackground(SWTResourceManager.getColor(215, 215, 215));
		
		Composite composite_2 = new Composite(composite, SWT.NONE);
		GridLayout gl_composite_2 = new GridLayout(1, false);
		gl_composite_2.marginWidth = 25;
		composite_2.setLayout(gl_composite_2);
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		Composite composite_3 = new Composite(composite_2, SWT.NONE);
		composite_3.setLayout(new GridLayout(1, false));
		GridData gd_composite_3 = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_composite_3.heightHint = 50;
		composite_3.setLayoutData(gd_composite_3);
		
		tableNameLabel = new Label(composite_3, SWT.NONE);
		tableNameLabel.setForeground(SWTResourceManager.getColor(68, 68, 68));
		tableNameLabel.setFont(SWTResourceManager.getFont("微软雅黑", 14, SWT.BOLD));
		tableNameLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		
		Composite composite_4 = new Composite(composite_2, SWT.NONE);
		composite_4.setBackground(SWTResourceManager.getColor(215, 215, 215));
		GridLayout gl_composite_4 = new GridLayout(1, false);
		gl_composite_4.verticalSpacing = 1;
		gl_composite_4.marginHeight = 1;
		gl_composite_4.marginWidth = 1;
		composite_4.setLayout(gl_composite_4);
		GridData gd_composite_4 = new GridData(SWT.FILL, SWT.TOP, true, false, 1, 1);
		gd_composite_4.heightHint = 360;
		composite_4.setLayoutData(gd_composite_4);
		
		detailComposite = new Composite(composite_4, SWT.NONE);
		detailComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_5 = new GridLayout(1, false);
		gl_composite_5.marginHeight = 0;
		gl_composite_5.marginWidth = 0;
		detailComposite.setLayout(gl_composite_5);
		detailComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		collectComposite = new Composite(composite_4, SWT.NONE);
		collectComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_collectComposite = new GridLayout(1, false);
		gl_collectComposite.marginHeight = 0;
		gl_collectComposite.marginWidth = 0;
		collectComposite.setLayout(gl_collectComposite);
		GridData gd_collectComposite = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_collectComposite.heightHint = 120;
		collectComposite.setLayoutData(gd_collectComposite);
		
	}
	
	/**
	 * @Description: 
	 * @author chenxw
	 * @param tenderId
	 * @param supplierId 
	 */
	public void refresh(String tenderId, String supplierId) {
		this.tenderId = tenderId;
		this.supplierId = supplierId;
		refreshBidPriceTableInfoList();
	}
	
	/**
	 * @Description: 
	 * @author chenxw 
	 */
	private void refreshBidPriceTableInfoList() {
		Arrays.stream(tableItemComposite.getChildren()).forEach(Widget::dispose);
		
		Optional<List<BidPriceTable>> bidPriceTableList = Optional
				.ofNullable(bidPriceTableService.getBidPriceTableInfoBySupplierId(tenderId, supplierId));
		
		Optional<BidPriceTable> bidPriceDetailTable = bidPriceTableList
				.map(List::stream)
				.flatMap(s -> s
						.filter(t -> BidPriceTableType.DETAIL.getKey().equals(t.getTableType()))
						.findAny());
		Optional<BidPriceTable> bidPriceCollectTable = bidPriceTableList
				.map(List::stream)
				.flatMap(s -> s
						.filter(t -> BidPriceTableType.COLLECT.getKey().equals(t.getTableType()))
						.findAny());
		
		addTableButton(bidPriceDetailTable.orElse(null), bidPriceCollectTable.orElse(null));
		
		bidPriceDetailTable.map(BidPriceTable::getBidPriceTableNameTitleValueMap).ifPresent(m -> 
		bidPriceDetailTable.map(BidPriceTable::getBidPriceTableItemList).ifPresent(l -> l.forEach(t -> 
		Optional.of(t).map(BidPriceTableItem::getSubDetalTableId).ifPresent(detalTableId -> 
		addTableItemButton(detalTableId, t.getSubCollectTableId(), Optional.ofNullable(m.get(t.getId())).orElse("未知报价表"))))));
		
		Arrays.stream(tableItemComposite.getChildren()).findFirst().ifPresent(c -> c.notifyListeners(SWT.MouseUp, null));
	}
	
	/**
	 * @Description: 
	 * @author chenxw
	 * @param bidPriceDetailTable
	 * @param bidPriceCollectTable 
	 */
	private void addTableButton(BidPriceTable bidPriceDetailTable, BidPriceTable bidPriceCollectTable) {
		BidPriceTableItemButton button = createBidPriceTableItemButton();
		button.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				switchButton(button);
				selectBidPriceTableItemAction(button.getText(), bidPriceDetailTable, bidPriceCollectTable);
			}
		});
		button.setText("报价汇总表");
		initESepator();
		refreshTableItemScrolled();
	}
	
	/**
	 * @Description: 
	 * @author chenxw
	 * @param bidPriceTableItem
	 * @param name 
	 */
	private void addTableItemButton(String subDetalTableId, String subCollectTableId, String name) {
		BidPriceTableItemButton button = createBidPriceTableItemButton();
		button.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				switchButton(button);
				selectBidPriceTableItemAction(
						button.getText().trim().concat("表"), 
						Optional.of(subDetalTableId).map(bidPriceTableService::getBidPriceTableInfoById).orElse(null), 
						Optional.ofNullable(subCollectTableId).map(bidPriceTableService::getBidPriceTableInfoById).orElse(null));
			}
		});
		button.setText(name);
		initESepator();
		refreshTableItemScrolled();
	}
	
	/**
	 * @Description: 创建投标报价表按钮
	 * @author chenxw
	 * @return 
	 */
	private BidPriceTableItemButton createBidPriceTableItemButton() {
		BidPriceTableItemButton button = new BidPriceTableItemButton(tableItemComposite, SWT.NONE);
		button.setSelectBgColor(ColorConstants.SKIN_BG);
		button.setSelectZtColor(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		button.setExpansion(true);
		return button;
	}
	
	/**
	 * @Description: 
	 * @author chenxw
	 * @param bidPriceDetailTable
	 * @param bidPriceCollectTable 
	 */
	private void selectBidPriceTableItemAction(String tableName, BidPriceTable bidPriceDetailTable, BidPriceTable bidPriceCollectTable) {
		tableNameLabel.setText(tableName);
		tableNameLabel.getParent().layout();
		
		refreshDetailComposite(bidPriceDetailTable);
		refreshCollectComposite(bidPriceCollectTable);
	}
	
	private void refreshDetailComposite(BidPriceTable bidPriceDetailTable) {
		Arrays.stream(detailComposite.getChildren()).forEach(Widget::dispose);
		KTable kTable = new KTable(detailComposite, SWTX.AUTO_SCROLL | SWT.FULL_SELECTION | SWTX.EDIT_ON_KEY);
		kTable.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		if (bidPriceDetailTable != null) {
			List<BidPriceTableItem> itemList = bidPriceDetailTable.getBidPriceTableItemList();
			List<BidPriceTableTitle> titleList = bidPriceDetailTable.getBidPriceTableTitleList();
			if (itemList != null && titleList != null) {
				CommonKtableCModel cModel = new CommonKtableCModel(kTable, 1, 0, itemList.size(), titleList.size());
				
				cModel.setContentRowHeight(Constants.ROW_HIGHT);
				
//				IntStream.range(0, titleList.size()).forEach(i -> 
//				Optional.of(titleList.get(i))
//						.map(BidPriceTableTitle::getWidth)
//						.map(width -> width.endsWith("%") ? width.substring(0, width.lastIndexOf("%")) : width)
//						.map(Integer::parseInt)
//						.ifPresent(w -> cModel.setColumnWidth(i, w*6)));
				
				Optional<Map<Keys, String>> valueMap = Optional.ofNullable(bidPriceDetailTable.getBidPriceTableValueMap());
				
				cModel.setCellContentRender((int row, int col) -> {
					if (row == 0) {
						return Optional.of(col).map(titleList::get).map(BidPriceTableTitle::getTitleName).orElse("未知列");
					}
					String tableTitleId = Optional.of(col).map(titleList::get).map(BidPriceTableTitle::getId).orElse(null);
					String tableItemId = Optional.of(row - 1).map(itemList::get).map(BidPriceTableItem::getId).orElse(null);
					return valueMap.map(m -> m.get(new Keys(tableTitleId, tableItemId))).orElse("");
				});
				cModel.setCellAlignmentRender((int row, int col) -> {
					if (row == 0) {
						return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_CENTER;
					}
					return Optional.of(col)
							.map(titleList::get)
							.map(BidPriceTableTitle::getContentAlignment)
							.map(ContentAlignment::getValueByKey)
							.map(i -> SWTX.ALIGN_VERTICAL_CENTER | i)
							.orElse(0);
				});
				cModel.setCellBackgroundRender((int row, int col) -> SWTResourceManager.getColor(SWT.COLOR_WHITE));
				
				kTable.setModel(cModel);
				kTable.autoComputerColumnWidth();
			}
		}
		detailComposite.layout();
	}

	private void refreshCollectComposite(BidPriceTable bidPriceCollectTable) {
		Optional<List<BidPriceTableItemCollect>> bidPriceTableItemCollectList = Optional.ofNullable(bidPriceCollectTable)
				.map(BidPriceTable::getBidPriceTableItemCollectList)
				.filter(l -> !l.isEmpty());
		WidgetUtils.setControlVisible(collectComposite, bidPriceTableItemCollectList.isPresent());
		collectComposite.getParent().layout();
		
		Arrays.stream(collectComposite.getChildren()).forEach(Widget::dispose);
		KTable kTable = new KTable(collectComposite, SWTX.AUTO_SCROLL | SWT.FULL_SELECTION | SWTX.EDIT_ON_KEY);
		kTable.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		bidPriceTableItemCollectList.ifPresent(l -> {
			CommonKtableCModel cModel = new CommonKtableCModel(kTable, 0, 0, l.size(), 2);
			cModel.setContentRowHeight(40);
			cModel.setCellContentRender((int row, int col) -> {
				return Optional.of(l.get(row)).map(t -> {
					if (col == 0) {
						return t.getCollectKey();
					}
					if (col == 1) {
						return t.getCollectValue();
					}
					return null;
				}).orElse("");
			});
			
			cModel.setCellAlignmentRender((int row, int col) -> SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_CENTER);
			cModel.setCellBackgroundRender((int row, int col) -> SWTResourceManager.getColor(SWT.COLOR_WHITE));
			
			kTable.setModel(cModel);
			kTable.autoComputerColumnWidth();
		
		});
		collectComposite.layout();
	}
	
	/**
	 * @Description: 
	 * @author chenxw
	 * @param button 
	 */
	private void switchButton(BidPriceTableItemButton button) {
		Optional.ofNullable(curButton).ifPresent(b -> b.setSelection(false));
		curButton = button;
		curButton.setSelection(true);
	}

	/**
	 * @Description: 
	 * @author chenxw 
	 */
	private void initESepator() {
		ESepator horizontal_label = new ESepator(tableItemComposite, SWT.SEPARATOR | SWT.HORIZONTAL);
		horizontal_label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		horizontal_label.setBackground(SWTResourceManager.getColor(215, 215, 215));
		horizontal_label.setLineStyle(SWT.LINE_DASH);
	}
	
	/**
	 * @Description: 
	 * @author chenxw 
	 */
	private void refreshTableItemScrolled() {
		tableItemComposite.layout();
		tableItemScrolled.setContent(tableItemComposite);
		tableItemScrolled.setMinSize(tableItemComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
	}
	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
