package com.gx.obe.bpt.entity;

import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.stream.Collectors;

import com.gx.obe.util.utils.Keys;

public class BidPriceTable {
	
	private String id;
	
	private String tenderId;
	
	private String supplierId;
	
	private String tableType;
	
	private String businessType;
	
	private String subjectTableId;
	
	private List<BidPriceTableItem> bidPriceTableItemList;
	private List<BidPriceTableTitle> bidPriceTableTitleList;
	private List<BidPriceTableValue> bidPriceTableValueList;
	
	private List<BidPriceTableItemCollect> bidPriceTableItemCollectList;
	
	public String getId() {
		return id;
	}
	
	public void setId(String id) {
		this.id = id;
	}
	
	public String getTenderId() {
		return tenderId;
	}
	
	public void setTenderId(String tenderId) {
		this.tenderId = tenderId;
	}
	
	public String getSupplierId() {
		return supplierId;
	}
	
	public void setSupplierId(String supplierId) {
		this.supplierId = supplierId;
	}
	
	public String getTableType() {
		return tableType;
	}
	
	public void setTableType(String tableType) {
		this.tableType = tableType;
	}
	
	public String getSubjectTableId() {
		return subjectTableId;
	}
	
	public void setSubjectTableId(String subjectTableId) {
		this.subjectTableId = subjectTableId;
	}
	
	public String getBusinessType() {
		return businessType;
	}
	
	public void setBusinessType(String businessType) {
		this.businessType = businessType;
	}
	
	public List<BidPriceTableItem> getBidPriceTableItemList() {
		return bidPriceTableItemList;
	}
	
	public void setBidPriceTableItemList(List<BidPriceTableItem> bidPriceTableItemList) {
		this.bidPriceTableItemList = bidPriceTableItemList;
	}
	
	public List<BidPriceTableTitle> getBidPriceTableTitleList() {
		return bidPriceTableTitleList;
	}
	
	public void setBidPriceTableTitleList(List<BidPriceTableTitle> bidPriceTableTitleList) {
		this.bidPriceTableTitleList = bidPriceTableTitleList;
	}
	
	public List<BidPriceTableValue> getBidPriceTableValueList() {
		return bidPriceTableValueList;
	}
	
	public Map<Keys, String> getBidPriceTableValueMap() {
		return Optional.ofNullable(getBidPriceTableValueList())
				.map(List::stream)
				.map(s -> s.collect(Collectors.toMap(Keys.fun(BidPriceTableValue::getTableTitleId, BidPriceTableValue::getTableItemId), BidPriceTableValue::getValue)))
				.orElse(null);
	}
	
	
	public Map<String, String> getBidPriceTableNameTitleValueMap() {
		Optional<String> tableTitleId = Optional.ofNullable(bidPriceTableTitleList)
				.map(List::stream)
				.flatMap(s -> s
						.filter(t -> "name".equals(t.getColType()))
						.findAny())
				.map(BidPriceTableTitle::getId);
		return Optional.ofNullable(bidPriceTableValueList)
				.map(List::stream)
				.map(s -> s
						.filter(t -> tableTitleId.isPresent() && tableTitleId.get().equals(t.getTableTitleId()))
						.collect(Collectors.toMap(BidPriceTableValue::getTableItemId, BidPriceTableValue::getValue)))
				.orElse(null);
	}
	
	public void setBidPriceTableValueList(List<BidPriceTableValue> bidPriceTableValueList) {
		this.bidPriceTableValueList = bidPriceTableValueList;
	}
	
	public List<BidPriceTableItemCollect> getBidPriceTableItemCollectList() {
		return bidPriceTableItemCollectList;
	}
	
	public void setBidPriceTableItemCollectList(List<BidPriceTableItemCollect> bidPriceTableItemCollectList) {
		this.bidPriceTableItemCollectList = bidPriceTableItemCollectList;
	}
	
}
