package com.gx.obe.bpt.enumeration;

import java.util.Arrays;
import org.eclipse.swt.SWT;
import de.kupzog.ktable.SWTX;

public enum ContentAlignment {
	
	ALIGNMENT_CENTER("alignmentCenter", SWTX.ALIGN_HORIZONTAL_CENTER, SWT.CENTER),
	
	ALIGNMENT_LEFT("alignmentLeft", SWTX.ALIGN_HORIZONTAL_LEFT, SWT.RIGHT);
	
	private String key;
	private int value;
	private int swtValue;
	
	private ContentAlignment(String key, int value, int swtValue) {
		this.key = key;
		this.value = value;
		this.swtValue = swtValue;
	}
	
	public String getKey() {
		return key;
	}
	
	public int getValue() {
		return value;
	}
	
	public int getSwtValue() {
		return swtValue;
	}
	
	public static int getValueByKey(String key) {
		return Arrays
				.stream(values())
				.filter(t -> t.getKey().equals(key))
				.findAny()
				.map(ContentAlignment::getValue)
				.orElse(0);
	}
	
	public static int getSwtValueByKey(String key) {
		return Arrays
				.stream(values())
				.filter(t -> t.getKey().equals(key))
				.findAny()
				.map(ContentAlignment::getSwtValue)
				.orElse(0);
	}
	
}
