package com.gx.obe.bpt.thread;

import java.util.Optional;

import com.gx.obe.bpt.parse.ParseBidPriceTable;
import com.gx.obe.bpt.utils.ParseBidPriceTableUtils;
import com.gx.obe.common.file.enumeration.FileConstants;

/**
 * @Description: 解析报价明细表线程
 * @author chenxw
 */
public class ParseBidPriceTableThread implements Runnable {
	
	private String tenderId;
	private String supplierId;
	
	/**
	 * @author chenxw
	 * @param tenderId
	 * @param supplierId
	 */
	public ParseBidPriceTableThread(String tenderId, String supplierId) {
		this.tenderId = tenderId;
		this.supplierId = supplierId;
	}
	
	@Override
	public void run() {
		String bidFilePath = FileConstants.getBidFilePath(tenderId, supplierId);
		new ParseBidPriceTable(tenderId, supplierId).parse(
				() -> ParseBidPriceTableUtils.resolverBidPriceTableElement(bidFilePath), 
				s -> Optional.ofNullable(s)
					.map(bidFilePath::concat)
					.map(ParseBidPriceTableUtils::resolverElementList)
					.orElse(null));
	}
	
}
